unit mVitals;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ImgList;

type
  TfraVitals = class(TFrame)
    lblVitals: TLabel;
    lvwVitals: TListView;
    imglstVitals: TImageList;
    procedure lvwVitalsClick(Sender: TObject);
    procedure lvwVitalsKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private

    { Private declarations }
  public
    { Public declarations }
    fVTemp,
      fVPulse,
      fVResp,
      fVBP,
      fVPain: TStringList;
    procedure LoadVitals;
    procedure RefreshVitals;
  end;

  TVitalTypes = (vtTemp,
    vtPulse,
    vtResp,
    vtBP,
    vtPain
    );

const
  VitalState: array[TVitalTypes] of integer =
  (3, 3, 3, 3, 3); //0=+ 1=- 2=blank 3=unknown

  VitalNames: array[TVitalTypes] of String =
  ('Temp', 'Pulse', 'Resp', 'BP', 'Pain'
  );

implementation

{$R *.dfm}
uses BCMA_Startup, BCMA_Common, BCMA_Objects, BCMA_Util;

procedure TfraVitals.LoadVitals;
var
  x: integer;
  tempStr: string;
begin
  if BCMA_Broker <> nil then
    with BCMA_Broker do
      if CallServer('PSB VITALS', [BCMA_Patient.IEN], nil) then
        if Results.Count - 1 <> StrToInt(Results[0]) then
          DefMessageDlg(ErrIncompleteData, mtError, [mbOK], 0)
        else if (results.Count > 1) and
          (piece(Results[1], '^', 1) = '-1') then
          DefMessageDlg(piece(Results[1], '^', 2), mtError, [mbOK], 0)
        else
          if Results.count > 1 then
            begin
              fVTemp := TStringList.Create;
              fVPain := TStringList.Create;
              fVBP := TStringList.Create;
              fVPulse := TStringList.Create;
              fVResp := TStringList.Create;

              for x := 0 to Results.Count - 1 do
                begin
                  tempStr := piece(results[x], '^', 1);
                  if tempStr = 'T' then
                    if fVtemp.Count = 0 then
                      fVTemp.AddObject(results[x], ptr(0))
                    else
                      fVTemp.AddObject(results[x], nil);
                  if tempStr = 'P' then
                    fVPulse.Add(results[x]);
                  if tempStr = 'R' then
                    fVResp.Add(results[x]);
                  if tempStr = 'BP' then
                    fVBP.Add(results[x]);
                  if tempStr = 'PN' then
                    fVPain.Add(results[x]);
                end;

              for x := 0 to length(VitalState) - 1 do
                VitalState[TVitalTypes(x)] := 3;
              RefreshVitals;
            end;

end;

procedure TfraVitals.lvwVitalsClick(Sender: TObject);
var
  x: integer;
begin
  with lvwVitals do
    begin
      if ItemIndex = -1 then exit;
      if items[ItemIndex].ImageIndex = 3 then exit;
      if items[ItemIndex].imageIndex = 4 then exit;
      if integer(Items[ItemIndex].Data) = -1 then exit;
      if VitalState[TVitalTypes(integer(Items[ItemIndex].Data))] = 0 then
        VitalState[TVitalTypes(integer(Items[ItemIndex].Data))] := 1
      else if VitalState[TVitalTypes(integer(Items[ItemIndex].Data))] = 1 then
        VitalState[TVitalTypes(integer(Items[ItemIndex].Data))] := 0;
      RefreshVitals;
    end;
end;

procedure TfraVitals.RefreshVitals;
var
  x: integer;
  ztest: string;

  procedure SetColumnData(VitalType: TVitalTypes; VitalsIn: TStringList);
  var
    x: integer;
  begin

    if VitalState[VitalType] = 3 then
      if VitalsIn.Count > 1 then VitalState[VitalType] := 0
      else VitalState[VitalType] := 2;


    case VitalState[VitalType] of
      0: //Plus
        with lvwVitals do
          begin
            AddItem(VitalNames[VitalType], ptr(integer(VitalType)));
            Items[Items.count - 1].SubItems.Add(piece(VitalsIn[0], '^', 4));
            Items[Items.count - 1].SubItems.Add(DisplayVADateYearTime(piece(VitalsIn[0], '^', 2)));
            Items[Items.count - 1].ImageIndex := VitalState[VitalType];
          end;

      1: //minus
        with lvwVitals do
          for x := 0 to VitalsIn.Count - 1 do
            if x = 0 then
              begin
                lvwVitals.AddItem(VitalNames[VitalType], ptr(integer(VitalType)));
                Items[Items.count - 1].SubItems.Add(piece(VitalsIn[x], '^', 4));
                Items[Items.count - 1].SubItems.Add(DisplayVADateYearTime(piece(VitalsIn[x], '^', 2)));
                Items[Items.count - 1].ImageIndex := VitalState[VitalType];
              end
            else if x = VitalsIn.Count - 1 then
              begin
                lvwVitals.AddItem('', ptr(-1));
                Items[Items.count - 1].SubItems.Add(piece(VitalsIn[x], '^', 4));
                Items[Items.count - 1].SubItems.Add(DisplayVADateYearTime(piece(VitalsIn[x], '^', 2)));
                Items[Items.count - 1].imageIndex := 4;
              end
            else
              begin
                lvwVitals.AddItem('', ptr(-1));
                Items[Items.count - 1].SubItems.Add(piece(VitalsIn[x], '^', 4));
                Items[Items.count - 1].SubItems.Add(DisplayVADateYearTime(piece(VitalsIn[x], '^', 2)));
                Items[Items.count - 1].ImageIndex := 3;
              end;
      2: //null pic, either only one entry or no entries
        with lvwVitals do
          begin
            if VitalsIn.Count = 0 then
              begin
                lvwVitals.AddItem(VitalNames[VitalType], ptr(integer(-1)));
                Items[Items.count - 1].SubItems.Add('');
                Items[Items.count - 1].SubItems.Add('No Entries Found');
                Items[Items.count - 1].ImageIndex := 2;
              end
            else
              begin
                lvwVitals.AddItem(VitalNames[VitalType], ptr(integer(-1)));
                Items[Items.count - 1].SubItems.Add(piece(VitalsIn[x], '^', 4));
                Items[Items.count - 1].SubItems.Add(DisplayVADateYearTime(piece(VitalsIn[x], '^', 2)));
                Items[Items.count - 1].ImageIndex := 2;
              end;
          end;
    end;
  end;

begin
  with lvwVitals do
    begin
      Clear;
      Columns[0].Width := 75;
      Columns[1].Width := 75;
      Columns[2].Width := Width - (Columns[0].Width + Columns[1].Width) - 25;
    end;


  SetColumnData(vtTemp, fvTemp);
  SetColumnData(vtPain, fvPain);
  SetColumnData(vtBP, fvBP);
  SetColumnData(vtPulse, fvPulse);
  SetColumnData(vtResp, fvResp);
  //  case VitalState[vtTemp] of
  //    3:

end;
procedure TfraVitals.lvwVitalsKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var x,y: integer;
begin
  if (key = VK_RIGHT) or (key = VK_LEFT) then
    with lvwVitals do
    begin
      if ItemIndex = -1 then exit;
      if integer(Items[ItemIndex].Data) = -1 then exit;
      y := ItemIndex;
      x := VitalState[TVitalTypes(integer(Items[ItemIndex].Data))];
      if x = 0 then
        VitalState[TVitalTypes(integer(Items[ItemIndex].Data))] := 1
      else if x = 1 then
        VitalState[TVitalTypes(integer(Items[ItemIndex].Data))] := 0;
      RefreshVitals;
      if (x = 0) or (x = 1) then
        begin
          lvwVitals.itemindex := y;
          lvwVitals.Items[y].Focused := True;
        end;

    end;

end;
end.

